<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Processus métier</title>
    <script src="index.min.js"></script>
    <script>
      const items = [
        {
          value: "a",
          img: "scenario-si-1.png"
        },
        {
          value: "b",
          img: "scenario-si-2.png"
        },
        {
          value: "c",
          img: "scenario-si-3.png"
        },
        {
          value: "d",
          img: "scenario-si-4.png"
        },
        {
          value: "e",
          img: "scenario-si-5.png"
        },
        {
          value: "f",
          img: "scenario-si-6.png"
        }
      ];
      function init() {
        const playgrid = document.querySelector(".playgrid");
        html = "";
        for (itemSrc of items) {
          html += `<div style="grid-area: ${itemSrc.value}"
          class="dropzone ${itemSrc.value}"></div>`;
        }
        playgrid.innerHTML = html;
      }
      function checkWin() {
        const correctItems = document.querySelectorAll(".playgrid .correct");
        const hasWon = correctItems.length === items.length;
        document.body.classList.toggle(
          "won",
          hasWon
        );

        if (hasWon) {
          // Return to the odoo admin home page
          setTimeout(() => {
            const params = (new URL(document.location)).searchParams;
            const userId = params.get("user_id");
            const scenarioId = params.get("scenario_id");
            const nextState = params.get("next_state");

            if (!userId || !scenarioId || !nextState) {
              window.location.replace('/web#home');
            }

            const url = `/aroollab/goto_state?user_id=${userId}&scenario_id=${scenarioId}&next_state=${nextState}`;
            fetch(url).then((response) => {
              window.location.replace('/web#home');
            }).catch((err) => {
              console.error("Failed to change user state");
              window.location.replace('/web#home');
            })
          }, 4000);
        }
      }

      function reset() {
        const source = document.querySelector(".source");
        const dropzones = document.querySelectorAll(".dropzone");
        for (dropzone of dropzones) {
          dropzone.innerHTML = "";
          dropzone.classList.remove(
            "correct",
            "incorrect",
            "draggable-dropzone--occupied"
          );
        }
        html = "";
        for (itemSrc of items) {
          html += `<div class="dropzone dropzone-source draggable-dropzone--occupied"><div
          class="item"
          style="background-image: url('${itemSrc.img}');"
          data-value="${itemSrc.value}"
          ></div></div>`;
        }
        source.innerHTML = html;
        checkWin();
      }

      function help() {
        if(confirm("Veux-tu voir la solution?")) {
          solve();
        }
      }

      function solve() {
        for (itemSrc of items) {
          const item = document.querySelector('[data-value="' + itemSrc.value + '"]');
          const dropzone = document.querySelector('.' + itemSrc.value);
          dropzone.append(item);
          dropzone.classList.remove("incorrect");
          dropzone.classList.add("correct");
        }
        checkWin();
      }

      document.addEventListener("DOMContentLoaded", () => {
        const droppable = new Draggable.Droppable(
          document.querySelectorAll(".container"),
          {
            draggable: ".item",
            dropzone: ".dropzone"
          }
        );
        droppable.on("droppable:start", (event) => {
          if (event.data.dropzone.classList.contains("correct"))
            return event.cancel();
          event.data.dropzone.classList.remove("correct", "incorrect");
        });
        droppable.on("droppable:stop", (event) => {
          if (event.data.dropzone.classList.contains("dropzone-source")) return;
          const dropzoneId = event.data.dropzone
            .computedStyleMap()
            .get("grid-area")
            .toString();
          const itemId = event.data.dragEvent.source.getAttribute("data-value");
          for (const child of event.data.dropzone.children) {
            if (event.data.dragEvent.source != child) {
              const firstEmpty = document.querySelector(
                ".dropzone-source:not(.draggable-dropzone--occupied)"
              );
              firstEmpty.append(child);
              firstEmpty.classList.add("draggable-dropzone--occupied");
            }
          }
          if (dropzoneId === itemId) {
            event.data.dropzone.classList.remove("incorrect");
            event.data.dropzone.classList.add("correct");
          } else {
            event.data.dropzone.classList.remove("correct");
            event.data.dropzone.classList.add("incorrect");
            event.data.dropzone.classList.remove(
              "draggable-dropzone--occupied"
            );
          }
          checkWin();
        });
        init();
        reset();
        const resetButton = document.querySelector(".reset-button");
        resetButton.addEventListener("click", reset);
        document.querySelector(".help").addEventListener("click", help);
      });
    </script>
    <style>
      *,
      *:before,
      *:after {
        -webkit-box-sizing: border-box;
        -moz-box-sizing: border-box;
        box-sizing: border-box;
      }
      body {
        font-family: Arial, sans-serif;
        text-align: center;
        margin: 0;
      }
      p {
        margin: 0.5em;
      }
      .reset-button {
        background: #eee;
        border: solid 1px #ccc;
        padding: 12px 15px;
        display: block;
        cursor: pointer;
        margin: 1em auto;
        min-width: 100px;
      }
      .container {
        align-items: center;
        justify-content: center;
        height: 100vh;
        display: flex;
        flex-direction: column;
        padding: 1em;
      }
      .source {
        display: flex;
        flex-wrap: wrap;
        min-height: 15vh;
      }
      .dropzone {
        display: flex;
        align-items: center;
        justify-content: center;
        padding: 5px;
        background-color: rgba(50, 50, 50, 0.2);
      }
      .dropzone.incorrect {
        background-color: rgba(255, 0, 0, 0.2);
      }
      .dropzone.correct {
        background-color: rgba(0, 255, 0, 0.2);
      }
      .won .dropzone.correct {
        background-color: transparent;
      }
      .source .dropzone {
        width: 15vh;
      }
      .target {
        display: flex;
      }
      .item {
        width: 100%;
        max-height: 100%;
        max-width: 15vh;
        background-position: center;
        background-repeat: no-repeat;
        background-size: contain;
        aspect-ratio: 1.5; /* ADAPT to fit */
        cursor: grab;
      }
      .playgrid {
        display: grid;
        grid-template-columns: 1fr 1fr 1fr 1fr 1fr 1fr 1fr;
        grid-template-rows: 1fr 1fr 1fr 1fr;
        grid-template-areas:
          ". . . . . . ."
          ". a b . . c ."
          ". . . . d . ."
          ". . e . f . .";
        background-image: url("scenario-si.png");
        background-position: center;
        background-repeat: no-repeat;
        background-size: contain;
        aspect-ratio: 1.97; /* ADAPT to background image */
        flex: 1;
        margin: 0.5em;
        max-width: 100%;
      }
      .show-won {
        display: none;
      }
      .won .hide-won {
        display: none;
      }
      .won .show-won {
        display: block;
      }
      .help {
        position: absolute;
        top: 2em;
        right: 2em;
        background-color: transparent;
        border: none;
      }
    </style>
  </head>
  <body>
    <div class="container">
      <h1>Processus métier : service d'aiguisage de couteaux</h1>
      <p>
        Glisse ces activités au bon endroit du processus pour modéliser notre
        nouveau service
      </p>
      <div class="source hide-won"></div>
      <div class="playgrid"></div>
      <div class="show-won">
        <h3>
          Bravo, tout est correct! Nous utiliserons ce processus pour mettre en
          place le service d'aiguisage.
        </h3>
      </div>
      <button class="reset-button hide-won">Recommencer</button>
      <button class="help hide-won">?</button>
    </div>
  </body>
</html>
